* device.s - part of execd
*

VERSION:	.reg	'0.52'
*PATCHLEVEL:	.reg	'0'


* Include File -------------------------------- *

		.include	doscall.mac


* Global Symbol ------------------------------- *

		.xref	dev_init


* Fixed Number -------------------------------- *

LF:		.equ	$0a
CR:		.equ	$0d

		.ifdef	__CRLF__
CRLF:		.reg	CR,LF
		.else
CRLF:		.reg	LF
		.endif


* Text Section -------------------------------- *

	.cpu	68000

	.text
	.even

dev_head::
		.dc.l	-1
		.dc	%1000_0000_0000_0000
		.dc.l	str_entry
		.dc.l	int_entry
keep_id::	.dc.b	'**EXEC**'

title_dev::	.dc.b	CRLF
title::		.dc.b	'exec bit driver',0

version_id::	.dc.b	'execd'
version_mes::	.dc.b	' version ',VERSION
	.ifdef	PATCHLEVEL
		.dc.b	' patchlevel ',PATCHLEVEL
	.endif
		.dc.b	CRLF,0
		.even

request_buffer:	.ds.l	1


str_entry:
		move.l	a5,(request_buffer)
		rts

int_entry:
		movem.l	d1-d7/a0-a6,-(sp)
		movea.l	(request_buffer,pc),a5
		tst.b	(2,a5)
		bne	command_error

		bsr	dev_init
int_entry_end:
		move	d0,-(sp)
		move.b	(sp)+,(4,a5)
		move.b	d0,(3,a5)
		movem.l	(sp)+,d1-d7/a0-a6
		rts

command_error:
		move	#$5003,d0
		bra	int_entry_end


* Work ---------------------------------------- *

		.even

orig_exec::	.ds.l	1

	.ifdef	CALL_GETPDB
getpdb::	.ds.l	1
	.endif

no_current_search::
		.dc.b	0
		.even

		.end

* End of File --------------------------------- *
